# Tests for locgen
#
# @Author: Christopher Hylands Brooks
#
# @Version: $Id: locgen.tcl,v 1.8.4.2 2005/02/18 01:51:31 cxh Exp $
#
# @Copyright (c) 2004 The Regents of the University of California.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software and that appropriate acknowledgments are made
# to the research of the Metropolis group.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
#
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
#######################################################################

# Load up the test definitions.
if {[string compare test [info procs test]] == 1} then {
    source testDefs.tcl
} {}

# Uncomment this to get a full report, or set in your Tcl shell window.
# set VERBOSE 1


set TESTDIR [pwd]
######################################################################
####
#
test locgen-1.1 {Run locgen with latency constraint violation} {
    cd ..
    exec make fir_violation.check
    set results [exec .[java::field java.io.File separator]fir_violation.check fir_trace.trc]
    cd "$TESTDIR"
    # This hack is necessary because of problems with crnl under windows
    regsub -all [java::call System getProperty "line.separator"] \
	$results "\n" results2
    set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]
   list $results3	
} {{
=========================================
            LOC Checker v0.1
   University of California, Riverside
=========================================

Reading from trace file(s): #1-"fir_trace.trc"

Constraint violated at trace file# 1 line# 12: Stimuli : 5 at time 59

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 5, where
-- t(Stimuli[i]) = 59
-- t(Display[i-5]) = 13

Constraint violated at trace file# 1 line# 14: Stimuli : 6 at time 69

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 6, where
-- t(Stimuli[i]) = 69
-- t(Display[i-5]) = 23

Constraint violated at trace file# 1 line# 16: Stimuli : 7 at time 79

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 7, where
-- t(Stimuli[i]) = 79
-- t(Display[i-5]) = 33

Constraint violated at trace file# 1 line# 18: Stimuli : 8 at time 89

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 8, where
-- t(Stimuli[i]) = 89
-- t(Display[i-5]) = 43

Constraint violated at trace file# 1 line# 20: Stimuli : 9 at time 99

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 9, where
-- t(Stimuli[i]) = 99
-- t(Display[i-5]) = 53

Constraint violated at trace file# 1 line# 22: Stimuli : 10 at time 109

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 10, where
-- t(Stimuli[i]) = 109
-- t(Display[i-5]) = 63

Constraint violated at trace file# 1 line# 24: Stimuli : 11 at time 119

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 11, where
-- t(Stimuli[i]) = 119
-- t(Display[i-5]) = 73

Constraint violated at trace file# 1 line# 26: Stimuli : 12 at time 129

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 12, where
-- t(Stimuli[i]) = 129
-- t(Display[i-5]) = 83

Constraint violated at trace file# 1 line# 28: Stimuli : 13 at time 139

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 13, where
-- t(Stimuli[i]) = 139
-- t(Display[i-5]) = 93

Constraint violated at trace file# 1 line# 30: Stimuli : 14 at time 149

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 14, where
-- t(Stimuli[i]) = 149
-- t(Display[i-5]) = 103

Constraint violated at trace file# 1 line# 32: Stimuli : 15 at time 159

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 15, where
-- t(Stimuli[i]) = 159
-- t(Display[i-5]) = 113

Constraint violated at trace file# 1 line# 34: Stimuli : 16 at time 169

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 16, where
-- t(Stimuli[i]) = 169
-- t(Display[i-5]) = 123

Constraint violated at trace file# 1 line# 36: Stimuli : 17 at time 179

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 17, where
-- t(Stimuli[i]) = 179
-- t(Display[i-5]) = 133

Constraint violated at trace file# 1 line# 38: Stimuli : 18 at time 189

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 18, where
-- t(Stimuli[i]) = 189
-- t(Display[i-5]) = 143

Constraint violated at trace file# 1 line# 40: Stimuli : 19 at time 199

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 19, where
-- t(Stimuli[i]) = 199
-- t(Display[i-5]) = 153

Constraint violated at trace file# 1 line# 42: Stimuli : 20 at time 209

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 20, where
-- t(Stimuli[i]) = 209
-- t(Display[i-5]) = 163

Constraint violated at trace file# 1 line# 44: Stimuli : 21 at time 219

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 21, where
-- t(Stimuli[i]) = 219
-- t(Display[i-5]) = 173

Constraint violated at trace file# 1 line# 46: Stimuli : 22 at time 229

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 22, where
-- t(Stimuli[i]) = 229
-- t(Display[i-5]) = 183

Constraint violated at trace file# 1 line# 48: Stimuli : 23 at time 239

Formula 't(Stimuli[i])-t(Display[i-5])<=45' is not satisfied at i = 23, where
-- t(Stimuli[i]) = 239
-- t(Display[i-5]) = 193

The LOC formula 't(Stimuli[i])-t(Display[i-5])<=45' with index i from 0 to 23 is evaluated.
Totally 19 error(s) found.

Maximum memory usage: 24 Bytes (Approximately)
Time elapsed: 0:0:0 -- 0 second(s)
}}


######################################################################
####
#
test locgen-2.1 {Run fir_violation.check with no args} {
    cd ..
    exec make fir_violation.check
    catch {set results [exec .[java::field java.io.File separator]fir_violation.check]}  errMsg
    cd "$TESTDIR"	
    # This hack is necessary because of problems with crnl under windows
    regsub -all [java::call System getProperty "line.separator"] \
	$errMsg "\n" results2
    set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]

   list $results3
} {{err: no trace file specified
usage: command file_name [file_name ...]
}}


######################################################################
####
#
test locgen-2.3 {Run fir_violation.check with unreadable file} {
   cd ..
   exec make fir_violation.check
   catch {[exec -stderrok .[java::field java.io.File separator]fir_violation.check this_file_does_not_exist]} errMsg
   cd "$TESTDIR"	
    # This hack is necessary because of problems with crnl under windows
    regsub -all [java::call System getProperty "line.separator"] \
	$errMsg "\n" results2
    set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]

   list $results3
} {{err: fail to open file "this_file_does_not_exist"
}}

######################################################################
####
#
test locgen-3.1 {Run locgen without latency constraint violation} {
   cd ..
   exec make fir_no_violation.check
   set results [exec .[java::field java.io.File separator]fir_no_violation.check fir_trace.trc]
   cd "$TESTDIR"	
   # This hack is necessary because of problems with crnl under windows
   regsub -all [java::call System getProperty "line.separator"] \
       $results "\n" results2
   set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]

   regsub {Time elapsed:.*$} $results3 {Time elapsed: M:N:S -- ? second(s)} r4
   list $r4
} {{
=========================================
            LOC Checker v0.1
   University of California, Riverside
=========================================

Reading from trace file(s): #1-"fir_trace.trc"

The LOC formula 't(Stimuli[i])-t(Stimuli[i-1])==10' with index i from 0 to 23 is evaluated.
No error!

Maximum memory usage: 8 Bytes (Approximately)
Time elapsed: M:N:S -- ? second(s)
}}

######################################################################
####
#
test locgen-4.1 {Run fir_no_violation.check with no args} {
   cd ..
   exec make fir_no_violation.check
   catch {set results [exec .[java::field java.io.File separator]fir_no_violation.check]}  errMsg
   cd "$TESTDIR"	
   # This hack is necessary because of problems with crnl under windows
   regsub -all [java::call System getProperty "line.separator"] \
       $errMsg "\n" results2
   set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]
   list $results3
} {{err: no trace file specified
usage: command file_name [file_name ...]
}}

######################################################################
####
#
test locgen-4.3 {Run fir_no_violation.check with unreadable file} {
   cd ..
   exec make fir_no_violation.check
   catch {[exec -stderrok .[java::field java.io.File separator]fir_no_violation.check this_file_does_not_exist]} results
   cd "$TESTDIR"	
   # This hack is necessary because of problems with crnl under windows
   regsub -all [java::call System getProperty "line.separator"] \
       $errMsg "\n" results2
   set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]
   list $results3
} {{err: no trace file specified
usage: command file_name [file_name ...]
}}

######################################################################
####
#
test locgen-5.1 {Run locgen with two args} {
   cd ..
   exec make equal_performance.check
   set results [exec .[java::field java.io.File separator]equal_performance.check np1.trc np2.trc]
   cd "$TESTDIR"
   # This hack is necessary because of problems with crnl under windows
   regsub -all [java::call System getProperty "line.separator"] \
       $results "\n" results2
   set results3 [string range $results2 0 \
		     [expr {[string length $results2] - 2}]]
   regsub {Time elapsed:.*$} $results3 {Time elapsed: M:N:S -- ? second(s)} r4

   list $r4
} {{
=========================================
            LOC Checker v0.1
   University of California, Riverside
=========================================

Reading from trace file(s): #1-"np1.trc"#2-"np2.trc"

The LOC formula 'pc(pipeline_NP1[i])==pc(pipeline_NP2[i])&&thread(pipeline_NP1[i])==thread(pipeline_NP2[i])&&microengine(pipeline_NP1[i])==microengine(pipeline_NP2[i])&&cycle(pipeline_NP1[i])-cycle(pipeline_NP2[i])<=i/21+8&&cycle(pipeline_NP2[i])-cycle(pipeline_NP1[i])<=i/21+8' with index i from 0 to 999 is evaluated.
No error!

Maximum memory usage: 32 Bytes (Approximately)
Time elapsed: M:N:S -- ? second(s)
}}

